<template>
  <v-container>
    <v-row class="pb-0">
      <v-col>
        <h2 class="mb-0">Create a Circle</h2>
      </v-col>
    </v-row>

    <v-row>
      <v-col xs="12" md="9">
        <v-form ref="form" v-model="valid">
          <v-row v-if="customErrors.length > 0">
            <v-col>
              <p
                v-for="(customError, index) in customErrors"
                :key="index"
                style="color: red;"
              >
                {{ customError }}
              </p>
            </v-col>
          </v-row>
          <v-row v-if="$store.state.circle.AddCircleStatus !== null">
            <v-col>
              <p
                v-if="$store.state.circle.AddCircleStatus === 'success'"
                style="color: green"
              >
                Success
              </p>
              <p v-if="$store.state.circle.AddCircleStatus === 'loading'">
                Loading...
              </p>
              <p
                v-if="$store.state.circle.AddCircleStatus === 'error'"
                style="color: red;"
              >
                {{ $store.state.circle.AddCircleErrorMessage }}
              </p>
            </v-col>
          </v-row>
          <p class="title">Group information</p>
          <v-row class="mb-3">
            <v-col sm="12">
              <image-upload :path="'circles'" :type="'circle'" />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Circle Title</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="title"
                dense
                :rules="rules"
                outlined
                label="My Circle"
                hide-details
                required
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Video Type</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="videoType"
                dense
                :items="['zoom', 'google hangouts', 'private video url']"
                :rules="rules"
                outlined
                label="Video type"
                required
                persistent-hint
                hint="You can select different platform to host your circle"
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col v-if="urlHelp && windowWidth < 600" cols="12">
              <v-label>{{ urlHelp }}</v-label>
            </v-col>
            <v-col xs="12" md="3">
              <v-label>Video meeting url</v-label>
            </v-col>
            <v-col xs="12" md="8" sm="12" class="text-right">
              <v-text-field
                v-model="videoURL"
                dense
                :rules="rules"
                outlined
                :label="urlHelp ? urlHelp : 'Paste your url here'"
                hide-details
                required
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Description</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-textarea
                v-model="description"
                label="Description"
                outlined
                rows="3"
                hide-details
                dense
              />
            </v-col>
          </v-row>

          <v-divider class="my-4" />

          <p class="title">Date & Time</p>
          <p class="caption">
            The time you choose below will be used as the starting point<br />
            and automatically determine all further recurring sessions for one
            slot.
          </p>
          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>When</v-label>
            </v-col>
            <v-col xs="12" md="4">
              <date-picker :date="dateItem.date" />
            </v-col>
            <v-col xs="12" md="4">
              <time-picker :time="dateItem.time" />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Duration</v-label>
            </v-col>
            <v-col xs="12" md="3">
              <v-select
                v-model="duration.hr"
                :items="Array.from(Array(24).keys())"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
            <v-col xs="12" md="1">Hr</v-col>
            <v-col xs="12" md="3">
              <v-select
                v-model="duration.min"
                :items="[0, 15, 30, 45]"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
            <v-col xs="12" md="1">min</v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Time Zone</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="dateItem.timeZone"
                :items="moment.tz.names()"
                :rules="rules"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Recurring group</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="recurringGroup"
                :items="[
                  { text: 'Yes', value: true },
                  { text: 'No', value: false }
                ]"
                outlined
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>

          <v-row v-if="recurringGroup" align="center">
            <v-col xs="12" md="3">
              <v-label>Will meet for circle</v-label>
            </v-col>
            <v-col xs="12" md="1">Every</v-col>
            <v-col xs="12" md="3">
              <v-select
                v-model="frequency.number"
                :items="Array.from(Array(10).keys())"
                :rules="rules"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
            <v-col xs="12" md="3">
              <v-select
                v-model="frequency.type"
                :items="['week', 'month']"
                outlined
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>

          <v-row v-if="recurringGroup" align="center">
            <v-col xs="12" md="3">
              <v-label>This is indefinitely group</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="indefinitelyGroup"
                :items="[
                  { text: 'Yes', value: true },
                  { text: 'No', value: false }
                ]"
                outlined
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>

          <v-row v-if="!indefinitelyGroup" align="center">
            <v-col xs="12" md="3">
              <v-label>Number of sessions</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="numberOfSessions"
                label="Number Of sessions"
                :rules="rules"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>

          <v-divider class="my-4" />

          <p class="title">Circle information</p>
          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Circle type</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <circle-types-select
                :add-circle-type="type => addCircleType(type)"
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Visibility</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="visibilityType"
                :items="visibilityTypes"
                label="Visibility"
                outlined
                item-text="type"
                item-value="value"
                hide-details
                required
                dense
              ></v-select>
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Number of participants</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="numOfParticipants"
                label="Number of participants"
                :rules="rules"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Price per session/package</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="price"
                :rules="rules"
                label="Price"
                outlined
                type="number"
                hide-details
                dense
                required
              />
            </v-col>
          </v-row>

          <v-row align="baseline">
            <v-col xs="12" md="3">
              <v-label>Tags</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-combobox
                v-model="labels"
                :items="labelsItems"
                :rules="rules"
                chips
                clearable
                label="Add tags to your circle"
                multiple
                outlined
                hint="Help pepole to find you by adding tags"
              >
                <template v-slot:selection="{ attrs, item, select, selected }">
                  <v-chip
                    v-bind="attrs"
                    :input-value="selected"
                    close
                    @click="select"
                    @click:close="remove(item)"
                  >
                    <strong>{{ item }}</strong
                    >&nbsp;
                  </v-chip>
                </template>
              </v-combobox>
            </v-col>
          </v-row>
        </v-form>
      </v-col>

      <v-col xs="12" md="3" class="pt-8">
        <div class="new-circle-right-side">
          <v-btn
            :loading="loading"
            block
            color="primary"
            outlined
            @click="addCircle()"
            >Add circle</v-btn
          >
          <v-card class="mt-6" outlined>
            <v-card-text>
              <p>App integration</p>
            </v-card-text>
          </v-card>
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import moment from 'moment'
import DatePicker from '@/components/Shared/UI/DatePicker'
import TimePicker from '@/components/Shared/UI/TimePicker'
import CircleTypesSelect from '@/components/Shared/UI/CircleTypesSelect'
import EventBus from '@/event-bus'
import { Labels } from '@/constants'
import ImageUpload from './CircleImage'

export default {
  name: 'FacilitatorDashboard',
  components: {
    TimePicker,
    DatePicker,
    CircleTypesSelect,
    ImageUpload
  },
  data: () => ({
    visibilityTypes: [
      { type: 'Public', value: true, id: 1 },
      { type: 'Private', value: false, id: 2 }
    ],
    labelsItems: Labels,
    rules: [v => !!v || 'This input is required!'],
    rulesVisibility: [v => v != null || 'This input is required!'],
    visibilityType: null,
    dateMenu: false,
    date: null,
    picker: false,
    time: null,
    dateItem: {
      time: null,
      date: null,
      timeZone: moment.tz.guess()
    },
    duration: {
      min: 0,
      hr: 0
    },
    frequency: {
      number: 1,
      type: 'week'
    },
    videoType: null,
    videoURL: null,
    title: null,
    circleType: null,
    numOfParticipants: null,
    price: null,
    description: '',
    valid: false,
    labels: [],
    loading: false,
    imageUrl: null,
    recurringGroup: false,
    indefinitelyGroup: false,
    numberOfSessions: 0,
    customErrors: []
  }),
  computed: {
    ...mapState('circle', ['AddCircleStatus']),
    ...mapState('app', ['stateImageUrl']),
    windowWidth() {
      return window.innerWidth
    },
    urlHelp() {
      if (this.videoType) {
        if (this.videoType === 'zoom') {
          return 'Please copy your zoom meeting url and paste it here.'
        }
      }
      return null
    }
  },
  watch: {
    '$store.state.circle.AddCircleStatus': function() {
      if (this.$store.state.circle.AddCircleStatus === 'success') {
        this.$refs.form.reset()
        this.$refs.form.resetValidation()
      }
    },
    customErrors: {
      handler(error) {
        if (error || this.$store.state.circle.AddCircleErrorMessage) {
          this.scrollToTop()
        }
      }
    }
  },
  beforeDestroy() {
    this.triggerSetAddCircleStatus('none')
  },
  created() {
    EventBus.$on('setDate', date => {
      this.dateItem.date = date
    })
    EventBus.$on('setTime', time => {
      this.dateItem.time = time
    })
    EventBus.$on('setCircleImageUrl', url => {
      this.imageUrl = url
    })
  },
  mounted() {
    // this.$store.commit('app/clearImageState')
  },
  methods: {
    ...mapActions('circle', ['triggerSetAddCircleStatus']),
    async addCircle() {
      const customValid = this.customValid()
      if (this.$refs.form.validate() && this.valid && customValid) {
        this.loading = true
        const data = {
          title: this.title,
          sessionDuration: this.duration,
          circleType: this.circleType,
          visibilityType: this.visibilityType,
          numOfParticipants: this.numOfParticipants,
          price: this.price,
          description: this.description,
          dateItem: this.dateItem,
          labels: this.labels,
          imageUrl: this.imageUrl,
          videoType: this.videoType,
          videoURL: this.videoURL,
          recurringGroup: this.recurringGroup,
          indefinitelyGroup: this.indefinitelyGroup,
          frequency: this.frequency
        }
        this.$store
          .dispatch('circle/createCircle', data)
          .then(() => {
            this.$router.push('/facilitator')
          })
          .catch(err => {
            console.log(err)
            this.loading = false
          })
      }
    },
    addCircleType(circleType) {
      this.circleType = circleType
    },
    customValid() {
      let status = true
      this.customErrors = []
      if (!this.stateImageUrl && !this.imageUrl) {
        let imageErrorExists = false
        this.customErrors.forEach(error => {
          if (error === 'You must upload circle image.') {
            imageErrorExists = true
          }
        })
        if (!imageErrorExists) {
          this.customErrors.push('You must upload circle image.')
        }
        status = false
      }
      if (!this.dateItem.time || !this.dateItem.date) {
        let dateErrorExists = false
        this.customErrors.forEach(err => {
          if (err === 'You must enter date and time.') {
            dateErrorExists = true
          }
        })
        if (!dateErrorExists) {
          this.customErrors.push('You must enter date and time.')
        }
        status = false
      }
      if (!this.duration.min && !this.duration.hr) {
        let durationErrorExists = false
        this.customErrors.forEach(err => {
          if (err === 'You must enter duration for hours or minutes.') {
            durationErrorExists = true
          }
        })
        if (!durationErrorExists) {
          this.customErrors.push(
            'You must enter duration for hours or minutes.'
          )
        }
        status = false
      }

      return status
    },
    scrollToTop() {
      window.scroll({
        top: 0,
        left: 0,
        behavior: 'smooth'
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.new-circle-right-side {
  position: sticky;
  top: 10%;
}
</style>
